SystemOrganization addCategory: #'Arduino-EtoysCompiler'!

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:11'!
detectMainMorph
	"Looks for the arduino board in which it is connected and returns it"
	"| ports |
	ports := #(#port1 #port2 #port3 #port4 #portA #portB #portC ).
	World allMorphsDo: [:morph |
		((morph isKindOf: LegoNxtMorph) and: [ports anySatisfy: [:port | (morph nxt perform: port) = device port]]) ifTrue: [^morph]].
	^ self error: 'The device is not plugged to any brick'"
	self halt! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:12'!
download: anArduinoCTranslatedProgram
	^ self detectMainMorph download: anArduinoCTranslatedProgram! !

!AttachableDeviceMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:12'!
playerTranslator
	^ self detectMainMorph playerTranslator! !

RBProgramNodeVisitor subclass: #ArduinoPlayerTranslator
	instanceVariableNames: 'mainMorph currentMorph'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Arduino-EtoysCompiler'!

!ArduinoPlayerTranslator class methodsFor: 'instance creation' stamp: 'Richo 8/11/2011 17:21'!
on: anArduinoMorph 
	^ self basicNew
			initializeWith: anArduinoMorph;
			yourself! !

!ArduinoPlayerTranslator methodsFor: 'initialize' stamp: 'Richo 8/11/2011 17:23'!
initializeWith: anArduinoMorph
	"By default we set the brick as the currentMorph"
	mainMorph := currentMorph := anArduinoMorph.
	self initialize! !

!ArduinoPlayerTranslator methodsFor: 'translating' stamp: 'Richo 8/11/2011 17:24'!
translateMainScript: aByteSymbol of: anArduinoMorph 
	self halt! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:05'!
detectMainMorph
	^ self! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
download: anArduinoCTranslatedProgram
	self halt.
"uploadOnPort: aByteString arduinoType: anArduinoType "! !

!ArduinoMorph methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
playerTranslator
	^ ArduinoPlayerTranslator on: self! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
getMode
	^ self costume renderedMorph isUsingCompiledMode
		ifTrue: [#compiled]
		ifFalse: [#direct] ! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:08'!
isUsingCompiledMode
	"An error might be signaled if this message is sent to an unplugged device"
	^ [self costume renderedMorph detectMainMorph isUsingCompiledMode] on: Error do: [false]! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
newScriptorAround: aPhrase
	| scriptEditor |
	Transcript show: 'newScriptorAround:'; cr.
	^ scriptEditor := super newScriptorAround: aPhrase.
	"^ NxtScriptEditorMorph fromScriptEditor: scriptEditor phrase: aPhrase"! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
scriptEditorFor: aSelector
	Transcript show: 'scriptEditorFor:'; cr.
	^ super scriptEditorFor: aSelector! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:09'!
scriptEditorForNoCng: aSelector
	Transcript show: 'scriptEditorForNoCng:'; cr.
	^ super scriptEditorForNoCng: aSelector.! !

!ArduinoPlayer methodsFor: '*arduino-etoyscompiler' stamp: 'Richo 8/11/2011 16:10'!
setMode: aSymbol
	self getMode = aSymbol ifTrue: [^self].
	aSymbol caseOf: {
		[#direct] -> [self costume renderedMorph useDirectMode].
		[#compiled] -> [self costume renderedMorph useCompiledMode].
	} otherwise: [^self].

	"Horrible hack below"
	World allMorphsDo: [:morph | | viewer |
		"Update scripts category of all opened viewers"
		((morph isKindOf: StandardViewer) and: [morph playerScripted isKindOf: self class officialClass]) 
			ifTrue: [morph updateScriptsCategory].
		"Also update closed viewers"
		((morph isKindOf: ViewerFlapTab) and: [(viewer := morph referent findA: StandardViewer) notNil])
			ifTrue: [viewer updateScriptsCategory].
		"Finally, update all opened script editors"
		((morph isKindOf: ScriptEditorMorph) and: [morph playerScripted isKindOf: self class officialClass]) 
			ifTrue: [morph replaceRow1; minWidth: nil]]! !
